---
title: Update Early Access Features
description: Use PUT {{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures to specify the early access feature or features that you want to opt-in to. The list of features available for your environment are returned by the Read Early Access Features request. The default for all early access features is opt-out, unless you specify a feature here.
component: pingone-api
page_id: pingone-api:platform:environments/early-access-features/update-early-access-features
canonical_url: https://developer.pingidentity.com/pingone-api/platform/environments/early-access-features/update-early-access-features.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Update Early Access Features

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures
```

Use `PUT {{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures` to specify the early access feature or features that you want to opt-in to. The list of features available for your environment are returned by the [Read Early Access Features](read-early-access-features.html) request. The default for all early access features is opt-out, unless you specify a feature here.

> **Collapse: Request Model**
>
> Refer to [Early Access Features](../early-access-features.html) for complete property descriptions.
>
> | Property      | Type    | Required? |
> | ------------- | ------- | --------- |
> | `name`        | String  | Required  |
> | `description` | String  | Optional  |
> | `segmentKey`  | String  | Required  |
> | `value`       | Boolean | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
  "features": [
   {
        "name": "Token Fulfillment from Authentication Context",
        "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
        "segmentKey": "token-fulfillment-from-authentication-context",
        "value": true
    }
  ]
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
  "features": [
   {
        "name": "Token Fulfillment from Authentication Context",
        "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
        "segmentKey": "token-fulfillment-from-authentication-context",
        "value": true
    }
  ]
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"  ""features"": [" + "\n" +
@"   {" + "\n" +
@"        ""name"": ""Token Fulfillment from Authentication Context""," + "\n" +
@"        ""description"": ""Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.""," + "\n" +
@"        ""segmentKey"": ""token-fulfillment-from-authentication-context""," + "\n" +
@"        ""value"": true" + "\n" +
@"    }" + "\n" +
@"  ]" + "\n" +
@"}" + "\n" +
@"";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures"
  method := "PUT"

  payload := strings.NewReader(`{
  "features": [
   {
        "name": "Token Fulfillment from Authentication Context",
        "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
        "segmentKey": "token-fulfillment-from-authentication-context",
        "value": true
    }
  ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/earlyAccessFeatures HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
  "features": [
   {
        "name": "Token Fulfillment from Authentication Context",
        "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
        "segmentKey": "token-fulfillment-from-authentication-context",
        "value": true
    }
  ]
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n  \"features\": [\n   {\n        \"name\": \"Token Fulfillment from Authentication Context\",\n        \"description\": \"Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.\",\n        \"segmentKey\": \"token-fulfillment-from-authentication-context\",\n        \"value\": true\n    }\n  ]\n}\n");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "features": [
      {
        "name": "Token Fulfillment from Authentication Context",
        "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
        "segmentKey": "token-fulfillment-from-authentication-context",
        "value": true
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "features": [
      {
        "name": "Token Fulfillment from Authentication Context",
        "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
        "segmentKey": "token-fulfillment-from-authentication-context",
        "value": true
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures"

payload = json.dumps({
  "features": [
    {
      "name": "Token Fulfillment from Authentication Context",
      "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
      "segmentKey": "token-fulfillment-from-authentication-context",
      "value": True
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n  "features": [\n   {\n        "name": "Token Fulfillment from Authentication Context",\n        "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",\n        "segmentKey": "token-fulfillment-from-authentication-context",\n        "value": true\n    }\n  ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "features": [
    {
      "name": "Token Fulfillment from Authentication Context",
      "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
      "segmentKey": "token-fulfillment-from-authentication-context",
      "value": true
    }
  ]
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n  \"features\": [\n   {\n        \"name\": \"Token Fulfillment from Authentication Context\",\n        \"description\": \"Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.\",\n        \"segmentKey\": \"token-fulfillment-from-authentication-context\",\n        \"value\": true\n    }\n  ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/earlyAccessFeatures")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/earlyAccessFeatures"
        }
    },
    "features": [
        {
            "name": "Configuration Management",
            "description": "Configuration management in PingOne allows for the promotion of configuration from one PingOne environment to another.  Both the source and target environment must be opted-into this capability in order to successfully promote. This is only available internally and limited to the APIs. See the beta API documentation for more details. ",
            "segmentKey": "configuration-management",
            "value": true
        },
        {
            "name": "Token Fulfillment from Authentication Context",
            "description": "Token Fulfillment from Authentication Context enables administrators to fulfill access and ID tokens based on the authentication JWT including claims within the authentication JWT by exposing the authentication context in the expression builder of the claims mapping. This feature improves interoperability with OpenID Connect (OIDC) applications by dynamically adapting token claims to match the token issuance requirements of different services.",
            "segmentKey": "token-fulfillment-from-authentication-context",
            "value": true
        }
    ]
}
```
